<?php

DEFINE ('TWITTER_USER','your_handle');
DEFINE ('CACHE_PATH','/path/to/the/cache/folder/ ');
DEFINE ('CACHE_FILE','twitter.cache');
DEFINE ('CACHE_LIFE',60); //time in seconds
DEFINE ('NUM_TWEETS',10); //number of tweets to retrieve


DEFINE ('YEAR', 31556926);
DEFINE ('MONTH',2629744);
DEFINE ('WEEK',604800);
DEFINE ('DAY',86400);
DEFINE ('HOUR',3600);
DEFINE ('MINUTE',60);

error_reporting(0);


function getTwitterData($cache_file){
  //echo '::RECREATING CACHE';
  
  $url='https://api.twitter.com/1/statuses/user_timeline.json?screen_name='.TWITTER_USER.'&include_rts=true&count='.NUM_TWEETS;

  //need to verify for valid stream from twitter, else return the old cache file
  if(!$json=file_get_contents($url)){
    echo "<span>Timeline served from cache</span>";
    return; 
  }
  
  if (file_exists($cache_file))
      unlink($cache_file);
  
  $stringData = microtime(true) . '::';
  $stringData .= parseTwitterData($json);
  
  $fh = fopen($cache_file, 'w') or die("can't open file");
  fwrite($fh, $stringData);
  fclose($fh);
}

function cacheExpired($cacheContents){
  $expired=false;
  $time = explode('::',$cacheContents);
  $delta = microtime(true) - floatval($time[0]);
  if ($delta>CACHE_LIFE){
    $expired=true;
    //echo '::CACHE EXPIRED';
  }
  return $expired;
}

function parseTwitterData($json){
  $obj = json_decode($json); 
  $str='';
  $str .= '<h3 style="margin-bottom:0;"><a href="http://twitter.com/'.TWITTER_USER.'">@'.TWITTER_USER.'</a></h3>';
  $str .= '<span>'. $obj[0]->user->name .'</span>';
  $str .= '<ul style="padding-top:15px;" class="tweets">';
  foreach($obj as $var => $value){
    $str .= '<li><img width="15" height="15" src="';
    $str .= $obj[$var]->user->profile_image_url;
    $str .= '" alt="'.$obj[$var]->user->screen_name.'"> ';
    $str .= linkify($obj[$var]->text);
    $str .= '<br /><span style="font-size:0.9em;color:#999; padding-top:3px;display:inline-block">' . fuzzy($obj[$var]->created_at) . '</span>';
    $str .= '</li>';
  }
  $str .= '</ul>';
  return $str;
}

function linkify($string) {
    // reg exp pattern
    $pattern = "/(http|https|ftp|ftps)\:\/\/[a-zA-Z0-9\-\.]+\.[a-zA-Z]{2,3}(\/\S*)?/";

    // convert string URLs to active links
    $new_string = preg_replace($pattern, "<a href=\"\\0\">\\0</a>", $string);
    
    $pattern = '/@([a-zA-Z0-9_]+)/';
    $replace = '<a href="http://twitter.com/\1">@\1</a>';
    $new_string = preg_replace($pattern, $replace, $new_string);

    return $new_string;
}


function fuzzy ($time){
  $time = substr($time,0,19);
  $time = strtotime($time) - (8*3600);
  $time = $time + (date('I')*3600);
  $now = time();
  
  $difference = $now - $time;
  
  if ( $difference < MINUTE ) {
    $result = ( 'menos de um minuto' );
  }
  else if ( $difference < HOUR ) {
    $minutes = round( $difference / MINUTE );
    $result = sprintf( _t( 'há %d minuto', 'há %d minutos', $minutes ), $minutes );
  }
  else if ( $difference < DAY ) {
    $hours = round( $difference / HOUR );
    $result = sprintf( _t( 'há %d hora', 'há %d horas', $hours ), $hours );
  }
  else if ( $difference < WEEK ) {
    $days = round( $difference / DAY );
    $result = sprintf( _t( 'há 1 dia', 'há %d dias', $days ), $days );
  }
  else if ( $difference < MONTH ) {
    $weeks = round( $difference / WEEK );
    $result = sprintf( _t( 'há 1 semana', 'há %d semanas', $weeks ), $weeks );
  }
  else if ( $difference < YEAR ) {
    $months = round( $difference / MONTH );
    $result = sprintf( _t( 'há 1 mês', 'há %d meses', $months ), $months );
  }
  else {
    $years = round( $difference / YEAR );
    $result = sprintf( _t( 'há 1 ano', 'há %d anos', $years ), $years );
  }
  
  return $result;
}
  
function _t($s,$p,$n){
  if ($n==1)
    return $s;
  else
    return $p;
}

/*-------------------------------------*/
$cache_file = CACHE_PATH . CACHE_FILE;

if (!file_exists($cache_file))
  getTwitterData($cache_file);

$fh = fopen($cache_file,'r');
$cacheContents = fread($fh, filesize($cache_file));
fclose($fh);

if (cacheExpired($cacheContents)){
  getTwitterData($cache_file);
  $fh = fopen($cache_file,'r');
  $cacheContents = fread($fh, filesize($cache_file));
  fclose($fh);
}

$return_str = explode('::',$cacheContents);

echo $return_str[1];
//echo 'Cache created on: '.$return_str[0] . '<br />' . $return_str[1];


?>